/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        24.10.2007
 Description:    Timer Routinen

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/
#include "config.h"

#if USE_CLOCK
#ifndef _CLOCK_H
	#define _CLOCK_H

	#include <avr/io.h>
	#include "usart.h"
	#include "ntp.h"

    //Mit oder ohne Debug-Ausgabe
//    #define CLOCK_DEBUG usart_write	//mit Debugausgabe
    #define CLOCK_DEBUG(...) 			//ohne Debugausgabe

 struct
      {
        unsigned char second;              // Sekunde
        unsigned char minute;              // Minute
        unsigned char hour;                // Stunde
        unsigned char day;                 // Tag 
        unsigned char month;               // Monat
        unsigned char year;                // Jahr
      } clock;

  void clock_inc(void);

#endif //_CLOCK_H
#endif
