/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        03.11.2007
 Description:    Webserver Config-File

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#ifndef _CONFIG_H_
	#define _CONFIG_H_	
	
	//ETH_M32_EX (www.ulrichradig.de)
	#define USE_ENC28J60	1

  //Watchdog timer for the ENC2860, resets the stack if timeout occurs
  #define WTT 1200 //Watchdog timer in timer interrupt (1s)

	//Umrechnung von IP zu unsigned long
	#define IP(a,b,c,d) ((unsigned long)(d)<<24)+((unsigned long)(c)<<16)+((unsigned long)(b)<<8)+a

	//IP des Webservers und des Routers
	#define MYIP		IP(192,168,0,99)
  #define ROUTER_IP	IP(192,168,0,1)

	//Netzwerkmaske
	#define NETMASK		IP(255,255,255,0) 
	
	//IP des NTP-Servers z.B. Server 1.de.pool.ntp.org
	#define USE_NTP		1 //1 = NTP Client on
	#define NTP_IP		IP(77,37,6,59)
  //NTP refresh before stack timeout occurs...
  #define NTP_REFRESH 1140
	
	//MAC Adresse des Webservers	
	#define MYMAC1	0x00
	#define MYMAC2	0x20
	#define MYMAC3	0x18
	#define MYMAC4	0xB1	
	#define MYMAC5	0x15
	#define MYMAC6	0x6F
	
	//Baudrate der seriellen Schnittstelle
	#define BAUDRATE 115200
		
	//Webserver mit Passwort? (0 == mit Passwort)
	#define HTTP_AUTH_DEFAULT	0
	
	//AUTH String "USERNAME:PASSWORT" max 14Zeichen 
	//fr Username:Passwort
	#define HTTP_AUTH_STRING "test:test"
  //#define HTTP_AUTH_STRING "user:pass"
	 
  // RFM12-Modul benutzen
  #define USE_RFM12       1

  // Software Uhr benutzen
  #define USE_CLOCK       0

  //Datei auf FTP speichern
  #define USE_FTP_CLIENT  0
  //FTP Send Data
#if USE_FTP_CLIENT
  #define FTP_SENDTIME 3600
  //IP des FTP-Servers 
  //Port des FTP-SERVERS
  #define FTP_PORT 21

  #define SERVER_FTP      1
   
#if SERVER_FTP == 1                       // NAS
  #define FTP_SERVER	IP(192,168,0,100)   
  #define FTP_USERNAME "test"
  #define FTP_PASSWORD "test"
  #define FTP_ORDNER "ftp/sensoren"
#elif SERVER_FTP == 2                     // VERSATEL
  #define FTP_SERVER	IP(xxx,xxx,xxx,xxx)   
  #define FTP_USERNAME "username"
  #define FTP_PASSWORD "password"
  #define FTP_ORDNER "htdocs/sensoren"
#endif

#endif  // USE_FTP_CLIENT     
#endif  //_CONFIG_H


