

#include "ftp_client.h"

#if USE_FTP_CLIENT

PROGMEM char FTP_USER_CMD[]  = "USER "FTP_USERNAME"\r\n";
PROGMEM char FTP_PASS_CMD[]  = "PASS "FTP_PASSWORD"\r\n";
PROGMEM char FTP_CWD_CMD[]   = "CWD "FTP_ORDNER"\r\n";
PROGMEM char FTP_PASV_CMD[]  = "PASV\r\n";
PROGMEM char FTP_TYPE_CMD[]  = "TYPE I\r\n";

PROGMEM char FTP_DATEN[]  = "Das ist ein Testfile\r\n";

static unsigned char ftp_status = FTP_CLOSE;
static unsigned char ftp_c_stat = FTP_CLOSE;
static unsigned char ftp_d_stat = FTP_CLOSE;

unsigned int  my_ftp_cp = 0;       // Controlport
unsigned int  my_ftp_dp = 0;       // Datenport
unsigned int  ftp_d_port = 0;      // Server Datenport

//----------------------------------------------------------------------------
//FTP Client Init
void ftp_client_init (void)
{
    //Eintragen der FTP Client Ports
    my_ftp_cp = 2345;
	  add_tcp_app (my_ftp_cp, (void(*)(unsigned char))ftp_control);

    my_ftp_dp = 2346;
	  add_tcp_app (my_ftp_dp, (void(*)(unsigned char))ftp_data);
    
    ftp_status = FTP_QUIT;
    ftp_c_stat = FTP_QUIT;
    ftp_d_stat = FTP_QUIT;
    ftp_timer = 10;
}

//----------------------------------------------------------------------------
//ACK vom FTP- Server an!! (Datenport)

void ftp_data (unsigned char index)
{
  if (tcp_entry[index].status & FIN_FLAG)
    {
  		FTP_DEBUG("ftp_data: FIN empfangen\r\n");
      ftp_d_stat = FTP_QUIT;
      return;
    }
  
  if (tcp_entry[index].status & ACK_FLAG)         // ACK fr voriges Paket?
    {
      if  (ftp_d_stat == FTP_READY)               // schon fertig?
        {
          ftp_send_data(index);                   // Daten senden
        }
    }
//  FTP_DEBUG("+++DATEN+++ index: %i app_status: %i status: %i\r\n",index,tcp_entry[index].app_status,tcp_entry[index].status);
}

//----------------------------------------------------------------------------
//Daten kommen vom FTP- Server an!! (Controlport)
// ACK + PSH gesetzt, app_status >= 2, erstes Paket vom Server
// ACK gesetzt, app_status >= 2, ACK fr von uns gesendete Daten
// ACK + FIN gesetzt, app_status = letzer app_status, vom Server bendet
// ??? gesetzt, app_status = ???, Paket nochmal senden
// FIN gesetzt, app_status = ???, wir haben beendet
void ftp_control (unsigned char index)
{
static unsigned char ftp_flag = 0;
      
    //Verbindung wurde abgebaut!
  if (tcp_entry[index].status & FIN_FLAG)
    {
  		FTP_DEBUG("ftp_control: FIN empfangen\r\n");
      return;
    }
 
  if (ftp_c_stat == FTP_OPEN)
    {
      unsigned int  message_code = 0; 
      unsigned char a, i = 0;
      char filename[24];
        
      message_code = atol((char*)&eth_buffer[TCP_DATA_START_VAR]);
    
      FTP_DEBUG("\r\n(ftp-control: Message Code: %i app_status: %i status: %i)\r\n",message_code,tcp_entry[index].app_status,tcp_entry[index].status);
      if ((tcp_entry[index].status & FIN_FLAG))
        {
          FTP_DEBUG("FIN ");
        }
      if ((tcp_entry[index].status & ACK_FLAG))
        {
          FTP_DEBUG("ACK ");
        }
      if ((tcp_entry[index].status & SYN_FLAG))
        {
          FTP_DEBUG("SYN ");
        }
      if ((tcp_entry[index].status & RST_FLAG))
        {
          FTP_DEBUG("RST ");
        }
      if ((tcp_entry[index].status & PSH_FLAG))
        {
          FTP_DEBUG("PSH ");
        }
      FTP_DEBUG("\r\n");

/*
      if (message_code != 0)
        {
          for (int a = TCP_DATA_START_VAR;a < TCP_DATA_END_VAR;a++)
            {
              FTP_DEBUG("%c",eth_buffer[a]);
            }
        }   
*/
      if (message_code >= 500)
        {
          FTP_DEBUG("8: FEHLER!\n\r");
            tcp_port_close(index);
            ftp_c_stat = FTP_CLOSE;                  // Control Kanal geschlossen
            ftp_flag = 0;        
        }
      else
        {   
          switch (message_code)
            {
              case 220:
                FTP_DEBUG("0: USER\n\r");
                memcpy_P(&eth_buffer[TCP_DATA_START_VAR],FTP_USER_CMD,sizeof(FTP_USER_CMD));		
               tcp_entry[index].status = ACK_FLAG | PSH_FLAG;
                create_new_tcp_packet(sizeof(FTP_USER_CMD)-1,index);
                break;
                
                case 331:
                FTP_DEBUG("1: PASS\n\r");
                memcpy_P(&eth_buffer[TCP_DATA_START_VAR],FTP_PASS_CMD,sizeof(FTP_PASS_CMD));	
                tcp_entry[index].status = ACK_FLAG | PSH_FLAG;
                create_new_tcp_packet(sizeof(FTP_PASS_CMD)-1,index);  
                break; 
                
              case 230:
                FTP_DEBUG("2: CWD\n\r");
                memcpy_P(&eth_buffer[TCP_DATA_START_VAR],FTP_CWD_CMD,sizeof(FTP_CWD_CMD));	
                tcp_entry[index].status = ACK_FLAG | PSH_FLAG;
                create_new_tcp_packet(sizeof(FTP_CWD_CMD)-1,index);  
                break;
  
              case 250:
                if (eth_buffer[TCP_DATA_START_VAR+4] == 'C')  // CMD
                  {
                    FTP_DEBUG("3: TYPE\n\r");
                    memcpy_P(&eth_buffer[TCP_DATA_START_VAR],FTP_TYPE_CMD,sizeof(FTP_TYPE_CMD));	
                    tcp_entry[index].status = ACK_FLAG | PSH_FLAG;
                    create_new_tcp_packet(sizeof(FTP_TYPE_CMD)-1,index);  
                    ftp_flag = 1;
                  }
                else
                  {
                    tcp_entry[index].status = ACK_FLAG;
                    create_new_tcp_packet(0,index);  
                  }
                break;    

              case 200:
                FTP_DEBUG("4: PASV\n\r");
                memcpy_P(&eth_buffer[TCP_DATA_START_VAR],FTP_PASV_CMD,sizeof(FTP_PASV_CMD));	
                tcp_entry[index].status = ACK_FLAG | PSH_FLAG;
                create_new_tcp_packet(sizeof(FTP_PASV_CMD)-1,index);  
                break;
                
              case 227:
                a = TCP_DATA_START_VAR;
                while (a < TCP_DATA_END_VAR)  // noch im Buffer und weniger als 6 Komma gefunden
                  {
                    if (eth_buffer[a] == ',')
                      {
                   		  i++;                 
                        if (i == 4)     // Port high
                          {
                            ftp_d_port = (atoi((char*)&eth_buffer[a+1]) << 8);
                          }
                        else if (i == 5)     // Port low
                          {
                            ftp_d_port |= (atoi((char*)&eth_buffer[a+1]) & 0xFF);
                            FTP_DEBUG("(Port: %i)\r\n",ftp_d_port);
                            break;
                          }
                      }               
                    a++;
                  }
                                       
                sprintf_P(filename, PSTR("STOR %02u%02u%02u_%02u%02u.csv\r\n"), clock.year,clock.month,clock.day,clock.hour,clock.minute);
            
                FTP_DEBUG("5: %s\n\r",filename);

                memcpy(&eth_buffer[TCP_DATA_START_VAR],filename,sizeof(filename));	
                tcp_entry[index].status = ACK_FLAG | PSH_FLAG;
                create_new_tcp_packet(sizeof(filename)-1,index);  

            		unsigned int my_ftp_dp_new = my_ftp_dp + time;
	  	          if (my_ftp_dp_new < 1000) my_ftp_dp_new +=1000;
		  
            		change_port_tcp_app (my_ftp_dp, my_ftp_dp_new);
		            my_ftp_dp = my_ftp_dp_new;

  			        FTP_DEBUG("FTP Datenport (%i)\r\n",my_ftp_dp);
	              tcp_port_open (FTP_SERVER,HTONS(ftp_d_port),HTONS(my_ftp_dp));  // Daten-Port ffnen
                ftp_flag = 0;
                break;

              case 150:
                if (ftp_flag == 0)
                  {
                    FTP_DEBUG("6: Daten bereit\n\r");
                    ftp_d_stat = FTP_OPEN;                   // Datenkanal bereit
                    ftp_flag = 1;
                    tcp_entry[index].status = ACK_FLAG;
                    create_new_tcp_packet(0,index);  
                  }
                break;

              case 226:
                FTP_DEBUG("7: Daten ok\n\r");
                tcp_port_close(index);
                ftp_c_stat = FTP_CLOSE;                  // Control Kanal geschlossen
                ftp_flag = 0;
            }
        }
    }
}

//----------------------------------------------------------------------------
//FTP Control-Kanal ffnen
void ftp_request (void)
{
  unsigned int index = 0;

  if (ftp_status != FTP_QUIT)                        // FTP starten
    {
	    if(ftp_status == FTP_START)                     // Control-Kanal ffnen
  	    {
		      //ffnet eine Verbindung zu einem FTP-Server
		      FTP_DEBUG("Send FTP-Datei\n\r");
			
		      //ARP Request senden
		      if (arp_request (FTP_SERVER))               // erstmal die MAC vom FTP-Server besorgen
		        {
			        for(unsigned long a=0;a<2000000;a++){asm("nop");};
			
          		unsigned int my_ftp_cp_new = my_ftp_cp + time;
		          if (my_ftp_cp_new < 1000) my_ftp_cp_new +=1000;
		
          		change_port_tcp_app (my_ftp_cp, my_ftp_cp_new);
		          my_ftp_cp = my_ftp_cp_new;
			        FTP_DEBUG("FTP Controlport (%i)\r\n",my_ftp_cp);
			        tcp_port_open (FTP_SERVER,HTONS(FTP_PORT),HTONS(my_ftp_cp));  // Port ffnen
			        // SYN wird gesetzt
 			        unsigned char tmp_counter = 0;          // Zhler fr Anzahl Versuche...
              do
                {    
    		          index = tcp_entry_search (FTP_SERVER,HTONS(FTP_PORT));
                  if (index >= MAX_TCP_ENTRY)         // nicht gefunden!
                    {
                      if (tmp_counter++ > 30)
                        {
                          ftp_status = FTP_QUIT;     // dann eben nicht!
                          ftp_timer = FTP_SENDTIME;   // spter nochmal nchste Runde...
                          return;
                        }
                    }

                  else if (tcp_entry[index].app_status == 1)
                    {
                      break;                          // ACK ist da, Verbindung steht  
                    }  

                }
			        while (index >= MAX_TCP_ENTRY);         // nichts gefunden...
              
              FTP_DEBUG("TCP Eintrag gefunden (FTP-Server)!\r\n");
              ftp_status = FTP_OPEN;
		          ftp_c_stat = FTP_OPEN;                  // Controll-Kanal offen
              return;
            }
          else
            {
	            FTP_DEBUG("ARP keine Antwort! (FTP-Server)\r\n");
              ftp_timer  = FTP_SENDTIME;
	            ftp_status = FTP_QUIT;                 // nicht erfolgreich
              return;           
            }
	      }

      if (ftp_d_stat == FTP_OPEN)                    // bereit zum Senden der Daten
        {
           index = tcp_entry_search (FTP_SERVER,HTONS(ftp_d_port));
           
           if (tcp_entry[index].app_status == 1)
            {
              FTP_DEBUG("Daten senden, app_status; %i\r\n",tcp_entry[index].app_status);
              ftp_send_data(index);
              ftp_d_stat = FTP_READY;                // erstes Paket gesendet
              return;
            }
        }        

      if (ftp_d_stat == FTP_CLOSE)                // fertig
        {
	        index = tcp_entry_search (FTP_SERVER,HTONS(ftp_d_port));
          FTP_DEBUG("Status; %i\r\n",tcp_entry[index].app_status);
        	
          tcp_port_close(index);
          ftp_d_stat = FTP_QUIT;
          FTP_DEBUG("Data closed\r\n");
          return;
        }

      if (ftp_c_stat == FTP_CLOSE)              // Control geschlossem
        {
          ftp_c_stat = FTP_QUIT;
          FTP_DEBUG("Control closed\r\n");
          return;
        }

      if (ftp_c_stat == FTP_OPEN)
        {
          index = tcp_entry_search (FTP_SERVER,HTONS(FTP_PORT));
          if (index >= MAX_TCP_ENTRY)               // Control nicht mehr gefunden!
            {
              index = tcp_entry_search (FTP_SERVER,HTONS(ftp_d_port));
              if (index >= MAX_TCP_ENTRY)       // Daten nicht mehr gefunden!
                {
                  ftp_c_stat = FTP_QUIT;
                  ftp_d_stat = FTP_QUIT;
                  ftp_status = FTP_QUIT;
                  ftp_timer  = 180;              // nochmal versuchen
                  FTP_DEBUG("Fehler!!!\r\n");
                  return;
                }
            }
        }

      if ((ftp_c_stat == FTP_QUIT) && (ftp_c_stat == FTP_QUIT))
        {
          ftp_status = FTP_QUIT;
          ftp_timer = FTP_SENDTIME;
        }
    }
  else
    {
    	if(!ftp_timer)
        {
          ftp_timer = FTP_SENDTIME;
          ftp_status = FTP_START;
        }
    }
  return;
}


//----------------------------------------------------------------------------
//FTP Daten senden
void ftp_send_data (unsigned char index)
{
  unsigned int  max_bytes, a;
  static unsigned char i = 0;

  max_bytes = sizeof(FTP_DATEN);

	a = sizeof(FTP_DATEN)-1;

  memcpy_P(&eth_buffer[TCP_DATA_START_VAR],FTP_DATEN,a);		

  if (i<10)
    {
		  //Erzeugte Packet kann nun gesendet werden!
      tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
	    create_new_tcp_packet(a,index);
      i++;
    }
   else
    {
      ftp_d_stat = FTP_CLOSE;          // alles ist raus 
      i = 0;
    } 
}

#endif //USE_FTP_CLIENT





