/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        20.04.2008
 Description:    Send MAIL Client

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/
#include <config.h>

#if USE_FTP_CLIENT
#ifndef _FTP_CLIENT_H
	#define _FTP_CLIENT_H

  #define FTP_CLOSE        0         // Kanal ist geschlossen
  #define FTP_OPEN         1         // Kanal ist offen
  #define FTP_READY        2         // Datenkanal 1. Paket gesendet

  #define FTP_START        3         // FTP soll starten
  #define FTP_QUIT         4         // FTP beendet
 
  #include <avr/io.h>
  #include <string.h>
	#include "usart.h"
  #include "base64.h"
	#include "stack.h"
     
    //Mit oder ohne Debug-Ausgabe
    #define FTP_DEBUG usart_write	//mit Debugausgabe
//    #define FTP_DEBUG(...) 			//ohne Debugausgabe

  	volatile unsigned int ftp_timer;
      
    void ftp_client_init (void);
    void ftp_request (void);
	  void ftp_control (unsigned char);
    void ftp_data (unsigned char);
    void ftp_send_data (unsigned char);

#endif //__FTP_CLIENT_H
#endif // USE_FTP_CLIENT


