/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        24.10.2007
 Description:    Webserver uvm.

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
----------------------------------------------------------------------------*/

#include <avr/io.h>
#include "config.h"
#include "usart.h"
#include "networkcard/enc28j60.h"
#include "stack.h"
#include "timer.h"
#include "httpd.h"
#include "ntp.h"
#include "clock.h"
#include "base64.h"
#include "ftp_client.h"
#include "RFM12.h"

//----------------------------------------------------------------------------
//Hier startet das Hauptprogramm
int main(void)
{  

  unsigned long a;

	for(a=0;a<1000000;a++){asm("nop");};

  usart_init(BAUDRATE);

  usart_write_str("Reset\r\n");

	//Applikationen starten
	stack_init();
	httpd_init();

  #if USE_RFM12
  rfm12_init();
  #endif

	//Ethernetcard Interrupt enable
	ETH_INT_ENABLE;
	
	//Globale Interrupts einschalten
	sei(); 
	
#if USE_NTP   
  ntp_init(); 
   
  for(a=0;a<1000000;a++){asm("nop");};
   
  ntp_request();
   
#endif //USE_NTP

#if USE_FTP_CLIENT
  ftp_client_init();
#endif
	
	while(1)
	{
	  eth_get_data();
		       

#if USE_CLOCK
  if (time_flag)
    {
      clock_inc();
      time_flag = 0;
    }
#endif

//Empfang von Zeitinformationen
#if USE_NTP
	if(!ntp_timer)
    {
		  ntp_timer = NTP_REFRESH;
		  ntp_request();
	  }
#endif //USE_NTP
		
// FTP-Send
#if USE_FTP_CLIENT
  ftp_request();
#endif
              
    if (ping.result)
      {
        ping.result = 0;
      }
    }//while (1)
		
  return(0);
}

